%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function enumerates the entire fesiable design space (Space_Design)
% by imposing restriction (Deck Area > 0 [m2], GM >= 0.15 [m] and Freeboard
% > 1.5 [m])on the design space enumerated by all combinations of the 
% design space variables (Space_Design_Var_full)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Space_Design] = Design_Compatibility(Design_Compatability_Matrix, Space_Design_Var_full,Space_Design_Fix_full, N_Var_Design, F_min, GM_min, DA_min)

N_Space_Design_Var_full = length(Space_Design_Var_full);

% Find infesiable Design configurations in Space_Design_Var_full
Comp(1:N_Space_Design_Var_full,1) = 1; % Initialize all to be fesiable
for ss = 1:N_Space_Design_Var_full
    System_Vector_current = Space_Design_Var_full(ss,:);
    for cc = 1:N_Var_Design
        for ccc = 1:N_Var_Design
            if Design_Compatability_Matrix{cc}(System_Vector_current(cc),System_Vector_current(ccc),ccc) == 2 || Space_Design_Fix_full(ss,1) < DA_min || Space_Design_Fix_full(ss,2) <= F_min || Space_Design_Fix_full(ss,4) < GM_min
               Comp(ss) = 2; % Design ss is infesiable
            end
        end
    end
end

Space_Design = []; % Create matrix to contain fesiable designs 
sss = 1; % counter
for ss = 1:N_Space_Design_Var_full
    System_Vector_current = Space_Design_Var_full(ss,:);
    if Comp(ss) == 1
        Space_Design(sss,:) = System_Vector_current;
        sss = sss + 1;
    end 
end 
end 



