%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Life Cycle Simulator 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Max number of interations
N_Interations_sim = 10;

% Life-cycle contribution
 con_total_sim = cell(N_Design,1); 
 for nn = 1:N_Design
   for ii = 1:N_Interations_sim
    con_total_sim{nn}(ii,1) = 0;
   end
 end

% Prepear matrixes for simulation 
action = cell(N_Design,1);
design = cell(N_Design,1);
strategy = cell(N_Design,1);
market = cell(N_Design,1);
requirement = cell(N_Design,1);
comp_tracker = cell(N_Interations_sim,1);
con = cell(N_Design,1);
mission = cell(N_Design,1);
state = cell(N_Design,1);

for ii = 1:N_Design
    for jj = 1:length(Space_State)
       for kk = 1: Lifetime + 2
           state{ii}(jj,kk) = 0;
       end
    end
end

for ii = 1:N_Design % Specify which design(s) to analyse
   iter = 1; 
   
   while iter <= N_Interations_sim
       
        % Initialie Starting State
        state_design = state_idx_start;
        state_strategy = 2;

       % Output information 
        fprintf('Design nr. %d, Interation nr. %d\n',ii, iter); 

        % Sample market and requirement for the given interation (Step. 1) 
        [Sample_Market_sim, Sample_Requirement_sim] = Sample_Path(Lifetime, TM_Requirement); 

        % Sample dayrates for the given interation (Step. 1 cont.)
        [Sample_DayRates_sim] = Sample_Dayrates(Sample_Market_sim, Lifetime,N_Strategy,N_Space_Mission,ScalingFactor,Dayrates_Data);
        
        % Track information 
        market{ii}(iter,:) = Sample_Market_sim; % Market State
        requirement{ii}(iter,:) = Sample_Requirement_sim; % Technical Requirement State
        
        % Simulate the vessel's lifetime (Step 2 in generic algorithm)
        tt_current = 2; % 2 represents year 5, 3 represents year 6, etc
        while tt_current < Lifetime + 2 
            
            tt_action = tt_current - 1; % Time when action is taken
            state_idx = find(Space_State(:,1) == state_design & Space_State(:,2) == state_strategy & Space_State(:,3) == Sample_Market_sim(tt_action) & Space_State(:,4) == Sample_Requirement_sim(tt_action)); 
            state{ii}(state_idx,tt_current) = state{ii}(state_idx,tt_current) + 1; 
            
            % Take action based on Policy
                if Policy{ii}(state_idx,tt_action)== 0
                    action{ii}(iter,tt_action) = randsample([1:N_Space_Action],1);
                else
                    action{ii}(iter,tt_action) = Policy{ii}(state_idx,tt_action);
                end
                
                design{ii}(iter,tt_current) = Space_Action(action{ii}(iter,tt_action),1);
                strategy{ii}(iter,tt_current) = Space_Action(action{ii}(iter,tt_action),2);
                
            % Calculate Switching time 
            SwitchDays = SDays(ii);
            
            % Estimate immediate Contribution
            [Comp] = Mission_Compatability(N_Space_Mission,N_Var_Design,Space_Design,Requirement_Matrix,requirement{ii}(iter,tt_current),design{ii}(iter,tt_current));
            comp_tracker{iter}(tt_current,:) = Comp;
            [contribution,rew,miss] = Contri(probwin,SellingCost, Sample_Market_sim(tt_action),OpDays, SwitchDays,ii, Comp, N_Space_Mission, Sample_DayRates_sim, strategy{ii}(iter,tt_current), tt_current, switch_cost, state_design, design{ii}(iter,tt_current), disc);
            con{ii}(iter,tt_current) = contribution; 
            con_total_sim{ii}(iter,1) = con_total_sim{ii}(iter,1) + contribution;
            mission{ii}(iter,tt_current) = miss;
            
            % Update information  
            state_design = design{ii}(iter,tt_current); 
            
            % Update time
            if strategy{ii}(iter,tt_current) == 1 % Short-term contract
                tt_current = tt_current + time_short;
            elseif strategy{ii}(iter,tt_current) == 2 % Long-term contract
                tt_current = tt_current + time_long;
            else % Vessel is sold
                tt_current = inf;
            end 
        end
        
        % Update interation counter
        iter = iter + 1;
   end  
   stateA = cell(N_Design,1);
   for jj = 1:length(Space_State)
       for kk = 1: Lifetime+2
           stateA{ii}(jj,kk) = state{ii}(jj,kk)/N_Interations_sim;
       end
   end
end

