%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function creates a compatability matrix, consisting of 1 and -inf
% representign wether or not the vessel is able to undertake a particular
% mission
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Comp] = Mission_Compatability(N_Space_Mission,N_Var_Design,Space_System,Requirement_Matrix,market_requirement,system_current)

NotValid = [];
for mi = 1:N_Space_Mission
    for vs = 1:N_Var_Design
        if Space_System(system_current,vs) < Requirement_Matrix{mi}(market_requirement,vs)
            NotValid(mi) = 1; % Do not hold requirement
            break
        else
            NotValid(mi) = 0; % Do hold requirement
        end
    end
    
    if NotValid == 1  % Design do not hold requirements
        Comp(mi) = -inf; % Not compatible
    else % Design holds requirements
        Comp(mi) = 1; % Compatible
    end
end